import React from 'react';
import {Link} from 'react-router';

import RaisedButton from 'material-ui/RaisedButton';
import Paper from 'material-ui/Paper';
import {Popover, PopoverAnimationVertical} from 'material-ui/Popover';
import {Menu, MenuItem} from 'material-ui/Menu';
import NavigationExpandMoreIcon from 'material-ui/svg-icons/navigation/expand-more';
import NavigationMenu from 'material-ui/svg-icons/navigation/menu';
import IconButton from 'material-ui/IconButton';
import ExitToApp from 'material-ui/svg-icons/action/exit-to-app';
import ActionAccountCircle from 'material-ui/svg-icons/action/account-circle';
import {Toolbar, ToolbarGroup, ToolbarTitle, ToolbarSeparator} from 'material-ui/Toolbar';
import {black} from 'material-ui/styles/colors';

var SBSToolbar = React.createClass({
  propTypes: {
    onToggleDrawer: React.PropTypes.func.isRequired,
    onLogout: React.PropTypes.func.isRequired,
    user: React.PropTypes.object.isRequired,
    popoverOpen: React.PropTypes.bool.isRequired,
    anchorEl: React.PropTypes.any,
    onTouchTapPopover: React.PropTypes.func.isRequired,
    onClosePopover: React.PropTypes.func.isRequired
  },
  contextTypes: {
    muiTheme: React.PropTypes.object.isRequired,
  },
  render: function() {
    return (
      <Paper style={{position:'fixed',width:"100%",zIndex:1301,height:'56px'}}>
        <Toolbar style={{backgroundColor: this.context.muiTheme.palette.primary1Color}}>
          <ToolbarGroup firstChild={true}>
            <IconButton
              onTouchTap={this.props.onToggleDrawer}
              >
              <NavigationMenu color={this.context.muiTheme.palette.alternateTextColor} />
            </IconButton>
            <ToolbarTitle text="SBS" style={{color: this.context.muiTheme.palette.alternateTextColor}}/>
          </ToolbarGroup>
          <ToolbarGroup lastChild={true}>
            <span style={{color: this.context.muiTheme.palette.alternateTextColor}}>{"v4.0.1.3"}</span>
            <ToolbarSeparator style={{backgroundColor: this.context.muiTheme.palette.alternateTextColor}}/>
            <RaisedButton
              label={(this.props.user) ? this.props.user.firstName + " " + this.props.user.lastName : "Unknown User"}
              labelPosition="before"
              secondary={true}
              icon={<NavigationExpandMoreIcon />}
              onTouchTap={this.props.onTouchTapPopover}
            />
            <Popover
              open={this.props.popoverOpen}
              anchorEl={this.props.anchorEl}
              anchorOrigin={{horizontal: 'right', vertical: 'bottom'}}
              targetOrigin={{horizontal: 'right', vertical: 'top'}}
              onRequestClose={this.props.onClosePopover}
              animation={PopoverAnimationVertical}
            >
              <Menu>
                <MenuItem
                  primaryText="Profile"
                  disabled={true}
                  leftIcon={
                    <ActionAccountCircle style={{verticalAlign:'middle',fill:black,marginRight:5}}/>
                  } />
                <MenuItem
                  primaryText="Admin"
                  containerElement={<Link to="/AdminView" />}
                  disabled={this.props.user.isAdmin ? false : true}
                  leftIcon={
                    <ActionAccountCircle style={{verticalAlign:'middle',fill:black,marginRight:5}}/>
                  } />
                <MenuItem
                  primaryText="Logout"
                  onTouchTap={this.props.onLogout}
                  leftIcon={
                    <ExitToApp style={{verticalAlign:'middle',fill:black,marginRight:5}}/>
                  } />
              </Menu>
            </Popover>
          </ToolbarGroup>
        </Toolbar>
      </Paper>
    );
  }
});
export default SBSToolbar;
