// actionTypes
const TOGGLE_DRAWER = "TOGGLE_DRAWER";
const TRANSITION_TO = "TRANSITION_TO";
const id = "material-ui-redux-navigation";
// action creators
export const toggleDrawer = () => ({
  type: TOGGLE_DRAWER
});
export const transitionTo = (feature) => ({
  type: TRANSITION_TO,
  feature: feature
});
// reducer
import { combineReducers } from 'redux';
// given state do a search through it to find a reducer with the id above
const findReducer = (state) => {
  var queue = [state];
  var seen = [];
  var currentNode;
  while (queue.length > 0){
    currentNode = queue.pop();
    seen.push(currentNode);
    if(currentNode.reducerId && currentNode.reducerId == id){
      return currentNode;
    }
    for (var key in currentNode) {
      // skip loop if the property is from prototype
      if (!currentNode.hasOwnProperty(key)) continue;

      var obj = currentNode[key];
      if(seen.indexOf(obj) == -1){
        queue.push(obj);
      }
    }
  }
};
export const changePageName = (dispatch,pageName) =>
  dispatch(transitionTo(pageName));
export const getIsDrawerOpen = (state) => {
  return findReducer(state).navigation.drawerOpen;
};
export const getCurrentPage = (state) => {
  return findReducer(state).navigation.page;
};
const drawerOpen = (state=false, action) => {
  switch (action.type) {
    case TOGGLE_DRAWER: return !state;
    default:
      return state;
  }
};

const page = (state="dashboard", action) => {
  switch (action.type) {
    case TRANSITION_TO: return action.feature;
    default:
      return state;
  }
};

const navigation = combineReducers({
  drawerOpen,
  page,
});
const reducerId = (state=id,action) => {
  return state;
};
const navigationId = combineReducers({
  navigation,
  reducerId,
});
//console.log(navigation);
export default navigationId;
